<template>
  <section class="chartsPage">
    <section class="chartHero">
      <div class="chartHero__bgHolder" v-bind:style="{ backgroundImage: 'url(images/main.jpg)' }"></div>
      <div class="chartHero__bgCover"></div>
      <div class="chartHero__content">
        <h1 class="chartHero__mainHeading">Discover top charts and albums</h1>
        <h2 class="chartHero__smallHeading">Explore music, entertainment and podcast Channels</h2>
        <h2 class="chartHero__smallHeading">The music you want. Anyware, anytime.</h2>
        <router-link to="/player">
          <md-button class="md-warn chartHero__btn">Explore Deezer TOP</md-button>
        </router-link>
      </div>
    </section>

    <h2 class="chartList__mainHeading">Trending Albums</h2>

    <section class="chartList" v-if="!state.contentLoaded">
      <div class="chartTiles__wrapper">
        <animated-placeholder width="514" height="222" v-bind:style="{ 'margin-right': '16px' }"></animated-placeholder>
        <animated-placeholder width="514" height="222"></animated-placeholder>
      </div>
    </section>

    <section class="chartList" v-if="state.contentLoaded">
      <div class="chartTiles__wrapper">
        <chart-tile 
          v-for="item in topAlbums" 
          v-bind:key="item.id" 
          v-bind:item="item" 
          v-on:onTileClick="navigateTo('album', item.id)"
          v-on:onTrackClick="navigateTo('track', item.id, $event)"/>
      </div>
    </section>

    <section class="chartList chartlist__cardsWrapper" v-if="!state.contentLoaded">
      <div class="chartlist__wrapper">
        <animated-placeholder
          v-for="(item, index) in fakeAlbums"
          v-bind:key="index"
          width="192"
          height="296"
          v-bind:style="{ 'margin': '10px 10px 14px 10px' }" />
      </div>
    </section>

    <section class="chartList chartlist__cardsWrapper" v-if="state.contentLoaded">
      <div class="chartlist__wrapper">
        <play-card 
          v-for="item in albums"
          v-bind:type="'track'"
          v-bind:key="item.id"
          v-bind:item="item"
          v-on:onCardClick="navigateTo('album', item.id)" />
      </div>
      <div class="chartList__loadMore">
        <md-button class="chartList__loadMoreBtn" @click="loadMore('albums')" v-bind:disabled="state.albumsLoadingMore">Load More</md-button>
      </div>
    </section>

    <h2 class="chartList__mainHeading" v-if="state.contentLoaded">Top Charts</h2>

    <section class="chartList" v-if="state.contentLoaded">
      <div class="chartTiles__wrapper">
        <chart-tile 
          v-for="item in topPlaylists"
          v-bind:key="item.id"
          v-bind:item="item"
          v-on:onTileClick="navigateTo('playlist', item.id)"
          v-on:onTrackClick="navigateTo('playlist', item.id, $event)" />
      </div>
    </section>

    <section class="chartList topChart__bottomSection chartlist__cardsWrapper" v-if="state.contentLoaded">
      <div class="chartlist__wrapper">
        <play-card 
          v-for="item in playlists"
          v-bind:key="item.id"
          v-bind:item="item"
          v-on:onCardClick="navigateTo('playlist', item.id)" />
      </div>
      <div class="chartList__loadMore">
        <md-button class="chartList__loadMoreBtn" @click="loadMore('playlists')" v-bind:disabled="state.playlistsLoadingMore">Load More</md-button>
      </div>
    </section>
  </section>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';
import { State, Getter } from 'vuex-class';

@Component({})
export default class HomePage extends Vue {
  @State(state => state.home)
  state;

  @Getter('homeAlbums') albums;
  @Getter('homeTopAlbums') topAlbums;
  @Getter('homePlaylists') playlists;
  @Getter('homeTopPlaylists') topPlaylists;

  fakeAlbums = Array.from({ length: 10 });

  currentAlbumPage = 1;
  currentChartPage = 1;
  ITEMS_PER_PAGE = 20;

  navigateTo(type, id, trackId) {
    this.$router.push({
      name: 'play',
      params: { type, id, trackId },
    });
  }

  created() {
    this.$store.dispatch('fetchAlbumsAndPlaylists', {
      perPage: this.ITEMS_PER_PAGE,
      page: 1,
    });
  }

  loadMore(type) {
    const page = type === 'albums' ? ++this.currentAlbumPage : ++this.currentChartPage;
    this.$store.dispatch('loadMoreContent', {
      type,
      page,
      perPage: this.ITEMS_PER_PAGE,
    });
  }

  destroyed() {
    this.$store.dispatch('resetHomepageState');
  } 
};
</script>

<style lang="stylus">
.chartHero
  height 320px
  background-color #000
  overflow hidden
  position relative

  &__bgHolder
    position absolute
    top 0
    bottom 0
    left 0
    right 0
    width 100%
    height 100%
    background-size cover
    background-repeat no-repeat

  &__bgCover
    background-color #1c212c
    opacity .85
    position absolute
    top 0
    bottom 0
    left 0
    right 0
    width 100%
    height 100%

  &__content
    position relative
    z-index 2
    padding 16px 24px
    margin-top  44px

  &__mainHeading
    margin 44px 0 20px 0
    font-size 34px
    font-family 'Encode Sans', sans-serif

  &__smallHeading
    font-weight 600
    color #8f94a0
    margin 0
    font-size 15px
    font-family 'Encode Sans', sans-serif

  &__btn.md-button
    margin 18px 0 0 0
    color #fff !important
    background-color #1c212c

.chartList
  padding 0 24px

  &__mainHeading
    margin 0
    padding 30px 24px
    font-size 18px
    font-family 'Encode Sans', sans-serif

  &__loadMore
    display flex
    justify-content center
  
  &__loadMoreBtn
    color #8f94a0 !important
    width 120px

.chartlist
  &__wrapper
    display flex
    flex-wrap wrap

  &__cardsWrapper
    padding 0 16px !important

.chartTiles__wrapper
  display flex
  margin-bottom 24px
  min-height 246px

.topChart__bottomSection
  margin-bottom 40px
</style>